## ardour 2.8.14

=== SConstruct ===
# -*- python -*-

#
# and there we have it, or do we?
#

import os
import os.path
import sys
import re
import shutil
import glob
import errno
import time
import platform
import string
import commands
from sets import Set
import SCons.Node.FS

SConsignFile()
EnsureSConsVersion(0, 96)

ardour_version = '2.8.14'

subst_dict = { }

#
# Command-line options
#

opts = Variables('scache.conf')
opts.AddVariables(
    ('ARCH', 'Set architecture-specific compilation flags by hand (all flags as 1 argument)',''),
    ('WINDOWS_KEY', 'Set X Modifier (Mod1,Mod2,Mod3,Mod4,Mod5) for "Windows" key', 'Mod4><Super'),
    ('PROGRAM_NAME', 'Set program name (default is "Ardour")', 'Ardour'),
    ('DIST_LIBDIR', 'Explicitly set library dir. If not set, Fedora-style defaults are used (typically lib or lib64)', ''),
    PathVariable('DESTDIR', 'Set the intermediate install "prefix"', '/'),
    PathVariable('PREFIX', 'Set the install "prefix"', '/usr/local'),
    EnumVariable('DIST_TARGET', 'Build target for cross compiling packagers', 'auto', 
          allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 'tiger', 'panther', 'leopard', 'none' ), ignorecase=2),
    BoolVariable('AUDIOUNITS', 'Compile with Apple\'s AudioUnit library. (experimental)', 0),
    BoolVariable('COREAUDIO', 'Compile with Apple\'s CoreAudio library', 0),
    BoolVariable('GTKOSX', 'Compile for use with GTK-OSX, not GTK-X11', 0),
    BoolVariable('OLDFONTS', 'Old school font sizes', 0),
    BoolVariable('DEBUG', 'Set to build with debugging information and no optimizations', 0),
    BoolVariable('STL_DEBUG', 'Set to build with Standard Template Library Debugging', 0),
    BoolVariable('DMALLOC', 'Compile and link using the dmalloc library', 0),
    BoolVariable('EXTRA_WARN', 'Compile with -Wextra, -ansi, and -pedantic.  Might break compilation.  For pedants', 0),
    BoolVariable('FFT_ANALYSIS', 'Include FFT analysis window', 1),
    BoolVariable('FREESOUND', 'Include Freesound database lookup', 1),
    BoolVariable('FPU_OPTIMIZATION', 'Build runtime checked assembler code', 1),
    BoolVariable('LIBLO', 'Compile with support for liblo library', 1),
    BoolVariable('NLS', 'Set to turn on i18n support', 1),
    BoolVariable('SURFACES', 'Build support for control surfaces', 1),
    BoolVariable('WIIMOTE', 'Build the wiimote control surface', 0),
    BoolVariable('SYSLIBS', 'USE AT YOUR OWN RISK: CANCELS ALL SUPPORT FROM ARDOUR AUTHORS: Use existing system versions of various libraries instead of internal ones', 0),
    BoolVariable('UNIVERSAL', 'Compile as universal binary.  Requires that external libraries are already universal.', 0),
    BoolVariable('VERSIONED', 'Add revision information to ardour/gtk executable name inside the build directory', 0),
    BoolVariable('VST', 'Compile with support for VST', 0),
    BoolVariable('LV2', 'Compile with support for LV2 (if Lilv is available)', 1),
    BoolVariable('LV2_UI', 'Compile with support for LV2 UIs (if Suil is available)', 1),
    BoolVariable('GPROFILE', 'Compile with support for gprofile (Developers only)', 0),
    BoolVariable('FREEDESKTOP', 'Install MIME type, icons and .desktop file as per the freedesktop.org spec (requires xdg-utils and shared-mime-info). "scons uninstall" removes associations in desktop database', 0),
    BoolVariable('TRANZPORT', 'Compile with support for Frontier Designs (if libusb is available)', 1),
    BoolVariable('AUBIO', "Use Paul Brossier's aubio library for feature detection", 1),
    BoolVariable('AUSTATE', "Build with support for AU settings & presets saving/loading", 0),
    BoolVariable('WITH_CARBON', "Build with support for Carbon AU GUIs", 1),
)

#----------------------------------------------------------------------
# a handy helper that provides a way to merge compile/link information
# from multiple different "environments"
#----------------------------------------------------------------------
#
class LibraryInfo(Environment):
    def __init__(self,*args,**kw):
        Environment.__init__ (self,*args,**kw)
        self.ENV_update(os.environ)
    
    def Merge (self,others):
        for other in others:
            self.Append (LIBS = other.get ('LIBS',[]))
            self.Append (LIBPATH = other.get ('LIBPATH', []))
            self.Append (CPPPATH = other.get('CPPPATH', []))
            self.Append (LINKFLAGS = other.get('LINKFLAGS', []))
            self.Append (CCFLAGS = other.get('CCFLAGS', []))
	self.Replace(LIBPATH = list(Set(self.get('LIBPATH', []))))
	self.Replace(CPPPATH = list(Set(self.get('CPPPATH',[]))))
        #doing LINKFLAGS breaks -framework
        #doing LIBS break link order dependency
    
    def ENV_update(self, src_ENV):
        for k in src_ENV.keys():
            if k in self['ENV'].keys() and k in [ 'PATH', 'LD_LIBRARY_PATH',
                                                  'LIB', 'PKG_CONFIG_PATH', 'INCLUDE' ]:
                self['ENV'][k]=SCons.Util.AppendPath(self['ENV'][k], src_ENV[k])
            else:
                self['ENV'][k]=src_ENV[k]

env = LibraryInfo (options = opts,
                   CPPPATH = [ '.' ],
                   VERSION = ardour_version,
                   TARBALL='ardour-' + ardour_version + '.tar.bz2',
                   DISTFILES = [ ],
                   DISTTREE  = '#ardour-' + ardour_version,
                   DISTCHECKDIR = '#ardour-' + ardour_version + '/check'
                   )

env.ENV_update(os.environ)

#----------------------------------------------------------------------
# Builders
#----------------------------------------------------------------------

# Handy subst-in-file builder
#

def do_subst_in_file(targetfile, sourcefile, dict):
    """Replace all instances of the keys of dict with their values.
    For example, if dict is {'%VERSION%': '1.2345', '%BASE%': 'MyProg'},
    then all instances of %VERSION% in the file will be replaced with 1.2345 etc.
    """
    try:
        f = open(sourcefile, 'rb')
        contents = f.read()
        f.close()
    except:
        raise SCons.Errors.UserError, "Can't read source file %s"%sourcefile
    for (k,v) in dict.items():
        contents = re.sub(k, v, contents)
    try:
        f = open(targetfile, 'wb')
        f.write(contents)
        f.close()
    except:
        raise SCons.Errors.UserError, "Can't write target file %s"%targetfile
    return 0 # success

def subst_in_file(target, source, env):
    if not env.has_key('SUBST_DICT'):
        raise SCons.Errors.UserError, "SubstInFile requires SUBST_DICT to be set."
    d = dict(env['SUBST_DICT']) # copy it
    for (k,v) in d.items():
        if callable(v):
            d[k] = env.subst(v())
        elif SCons.Util.is_String(v):
            d[k]=env.subst(v)
        else:
            raise SCons.Errors.UserError, "SubstInFile: key %s: %s must be a string or callable"%(k, repr(v))
    for (t,s) in zip(target, source):
        return do_subst_in_file(str(t), str(s), d)

def subst_in_file_string(target, source, env):
    """This is what gets printed on the console."""
    return '\n'.join(['Substituting vars from %s into %s'%(str(s), str(t))
                      for (t,s) in zip(target, source)])

def subst_emitter(target, source, env):
    """Add dependency from substituted SUBST_DICT to target.
    Returns original target, source tuple unchanged.
    """
    d = env['SUBST_DICT'].copy() # copy it
    for (k,v) in d.items():
        if callable(v):
            d[k] = env.subst(v())
        elif SCons.Util.is_String(v):
            d[k]=env.subst(v)
    Depends(target, SCons.Node.Python.Value(d))
    # Depends(target, source) # this doesn't help the install-sapphire-linux.sh problem
    return target, source

subst_action = Action (subst_in_file, subst_in_file_string)
env['BUILDERS']['SubstInFile'] = Builder(action=subst_action, emitter=subst_emitter)

#
# internationalization
#

# po_builder: builder function to copy po files to the parent directory while updating them
#
# first source:  .po file
# second source: .pot file
#

def po_builder(target,source,env):
    os.spawnvp (os.P_WAIT, 'cp', ['cp', str(source[0]), str(target[0])])
    args = [ 'msgmerge',
             '--update',
             str(target[0]),
             str(source[1])
             ]
    print 'Updating ' + str(target[0])
    return os.spawnvp (os.P_WAIT, 'msgmerge', args)

po_bld = Builder (action = po_builder)
env.Append(BUILDERS = {'PoBuild' : po_bld})

# mo_builder: builder function for (binary) message catalogs (.mo)
#
# first source:  .po file
#

def mo_builder(target,source,env):
    args = [ 'msgfmt',
             '-c',
             '-o',
             target[0].get_path(),
             source[0].get_path()
             ]
    return os.spawnvp (os.P_WAIT, 'msgfmt', args)

mo_bld = Builder (action = mo_builder)
env.Append(BUILDERS = {'MoBuild' : mo_bld})

# pot_builder: builder function for message templates (.pot)
#
# source: list of C/C++ etc. files to extract messages from
#

def pot_builder(target,source,env):
    args = [ 'xgettext',
             '--keyword=_',
             '--keyword=N_',
             '--from-code=UTF-8',
             '-o', target[0].get_path(),
             "--default-domain=" + env['PACKAGE'],
             '--copyright-holder="Paul Davis"' ]
    args += [ src.get_path() for src in source ]
    
    return os.spawnvp (os.P_WAIT, 'xgettext', args)

pot_bld = Builder (action = pot_builder)
env.Append(BUILDERS = {'PotBuild' : pot_bld})

#
# utility function, not a builder
#

def i18n (buildenv, sources, installenv):
    domain = buildenv['PACKAGE']
    potfile = buildenv['POTFILE']

    #
    # on glibc systems, libintl is part of libc. not true on OS X
    #
    
    if re.search ("darwin[0-9]", config[config_kernel]):
        buildenv.Merge ([ libraries['intl'] ])

    installenv.Alias ('potupdate', buildenv.PotBuild (potfile, sources))
    
    p_oze = [ os.path.basename (po) for po in glob.glob ('po/*.po') ]
    languages = [ po.replace ('.po', '') for po in p_oze ]
    
    for po_file in p_oze:
        buildenv.PoBuild(po_file, ['po/'+po_file, potfile])
        mo_file = po_file.replace (".po", ".mo")
        installenv.Alias ('install', buildenv.MoBuild (mo_file, po_file))
        installenv.Alias ('msgupdate', buildenv.MoBuild (mo_file, po_file))
    
    for lang in languages:
        modir = (os.path.join (install_prefix, 'share/locale/' + lang + '/LC_MESSAGES/'))
        moname = domain + '.mo'
        installenv.Alias('install', installenv.InstallAs (os.path.join (modir, moname), lang + '.mo'))


def fetch_svn_revision (path):
    cmd = "LANG= "
    cmd += "svn info "
    cmd += path
    cmd += " 2>/dev/null | awk '/^Revision:/ { print $2}'"
    return commands.getoutput (cmd)

def create_stored_revision (target = None, source = None, env = None):
    if os.path.exists('.svn'):    
        rev = fetch_svn_revision ('.');
        try:
            text  = "#include <ardour/svn_revision.h>\n"
            text += "namespace ARDOUR {\n";
            text += "extern const char* svn_revision = \"" + rev + "\";\n";
            text += "}\n";
            print '============> writing svn revision info to libs/ardour/svn_revision.cc\n'
            o = file ('libs/ardour/svn_revision.cc', 'w')
            o.write (text)
            o.close ()
        except IOError:
            print "Could not open libs/ardour/svn_revision.cc for writing\n"
            sys.exit (-1)
    else:
        if not os.path.exists('libs/ardour/ardour/svn_revision.h'):    
            print "This release of ardour is missing libs/ardour/ardour/svn_revision.h. Blame the packager."
            sys.exit (-1)

#
# A generic builder for version.cc files
#
# note: requires that DOMAIN, MAJOR, MINOR, MICRO are set in the construction environment
# note: assumes one source files, the header that declares the version variables
#

def version_builder (target, source, env):

    text  = "int " + env['DOMAIN'] + "_major_version = " + str (env['MAJOR']) + ";\n"

=== debian/changelog ===
ardour (1:2.8.14-2) unstable; urgency=low

  * Bump policy to 3.9.4
  * Build-depend on libsuil-dev to enable LV2 GUIs (Closes: #690001)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 09 Oct 2012 13:55:59 +0200

ardour (1:2.8.14-1) unstable; urgency=low

  * Imported Upstream version 2.8.14 (Closes: #684610)
  * Drop obsolete patches that were merged upstream

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sat, 11 Aug 2012 21:07:46 +0200

ardour (1:2.8.12+svn12923-1) unstable; urgency=low

  * Imported Upstream version 2.8.12+svn12923 (Closes: #678151)
  * Disable ardourino support. If you need it, please file a bug report.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Mon, 25 Jun 2012 17:29:09 +0200

ardour (1:2.8.12-2) unstable; urgency=low

  * Team upload.

  [ Jaromír Mikeš ]
  * Little fix in license reference

  [ Alessio Treglia ]
  * Fix FTBFS with GCC 4.7.
    Thanks to Matthias Klose for the patch. (Closes: #667101)
  * Replace lv2core with lv2-dev in Build-Depends.

 -- Alessio Treglia <alessio@debian.org>  Thu, 17 May 2012 11:02:30 +0200

=== debian/control ===
Source: ardour
Section: sound
Priority: extra
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Free Ekanayaka <freee@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 autotools-dev,
 devscripts,
 debhelper,
 dh-buildinfo,
 gettext,
 intltool,
 scons,
 libboost-dev,
 libcurl4-gnutls-dev,
 libfftw3-dev,
 libraptor1-dev (>= 1.4.21-5),
 liblrdf0-dev (>= 0.4.0-4),
 libsigc++-2.0-dev,
 libusb-dev,
 libxml2-dev (>= 2.5.7),
 librasqal3-dev | librasqal2-dev (>= 0.9.14),
 libcairomm-1.0-dev (>= 1.2.4),
 libglade2-dev,
 libglademm-2.4-dev,
 libglib2.0-dev,
 libgnomecanvas2-dev,
 libgnomecanvasmm-2.6-dev,
 libgtkmm-2.4-dev,
 libpango1.0-dev,
 ladspa-sdk (>= 1.1-2),
 libasound2-dev (>= 0.9.4) [linux-any],
 liboss-salsa-dev [!linux-any],
 libaubio-dev,
 libjack-dev,
 liblo-dev,
 libsuil-dev,
 libsamplerate0-dev,
 libslv2-dev (>= 0.6.6-7),
 libsndfile1-dev,
 libsoundtouch-dev (>= 1.5.0),
 lv2-dev,
 liblilv-dev,
 vamp-plugin-sdk (>=2.1)
Standards-Version: 3.9.4
DM-Upload-Allowed: yes
Homepage: http://www.ardour.org/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/ardour.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/ardour.git;a=summary

Package: ardour
Architecture: any
Depends: ${shlibs:Depends},
 ${python:Depends},
 ${misc:Depends},
 ${cdbs:Depends}
Recommends: ${cdbs:Recommends}
Suggests: ${shlibs:Suggests}
Conflicts: ${cdbs:Conflicts}
Replaces: ${cdbs:Replaces}
Description: digital audio workstation (graphical gtk2 interface)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups. 
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <http://ardour.org/>.

Package: ardour-altivec
Architecture: powerpc
Depends: ${shlibs:Depends},
 ${python:Depends},
 ${misc:Depends},
 ${cdbs:Depends}
Recommends: ${cdbs:Recommends}
Suggests: ${shlibs:Suggests}
Provides: ${cdbs:Provides}
Conflicts: ${cdbs:Conflicts}
Replaces: ${cdbs:Replaces}
Description: digital audio workstation (graphical gtk2 interface) [altivec]
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups. For more information see the description
 of the ardour package or <http://ardour.org/>.
 .
 This package is optimized for altivec and will not run on
 subarchitectures that don't support features enabled in altivec.
 It might fail with weird error SIGILLs and other non-obvious failures.
 Please refrain from filling bugs to the upstream author about this package
 that are not reproducible in the non-optimized package.

Package: ardour-i686
Architecture: i386
Depends: ${shlibs:Depends},
 ${python:Depends},
 ${misc:Depends},
 ${cdbs:Depends}
Recommends: ${cdbs:Recommends}
Suggests: ${shlibs:Suggests}
Provides: ${cdbs:Provides}
Conflicts: ${cdbs:Conflicts}
Replaces: ${cdbs:Replaces}
Description: digital audio workstation (graphical gtk2 interface) [i686]
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups. For more information see the description
 of the ardour package or <http://ardour.org/>.
 .
 This package is optimized for i686 and will not run on
 subarchitectures that don't support features enabled in i686.
 It might fail with weird error SIGILLs and other non-obvious failures.
 Please refrain from filling bugs to the upstream author about this package
 that are not reproducible in the non-optimized package.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

include /usr/share/cdbs/1/class/langcore.mk
include /usr/share/cdbs/1/rules/buildcore.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
DEB_CLEAN_EXCLUDE=debian/tmp
# temporary hack for unclean upstream codebase
DEB_CLEAN_EXCLUDE += libs/clearlooks-newer/support.h.orig
DEB_DESTDIR = $(CURDIR)/debian/tmp/

NJOBS = $(DEB_PARALLEL_JOBS:%=-j%)

ALTIVEC_OPT_FLAGS := -O3 -mcpu=7400 -maltivec -mabi=altivec -mhard-float -mpowerpc-gfxopt
I686_OPT_FLAGS := -O3 -march=i686 -mmmx

DEB_SCONS_EXTRA_FLAGS := \
	PREFIX=/usr \
	NLS=yes \
	FREEDESKTOP=no \
	$(NJOBS) \
	SYSLIBS=yes \
	FREESOUND=yes \
	VST=0

DEB_SCONS_NOOPT_FLAGS := DEBUG=no FPU_OPTIMIZATION=no
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
DEB_SCONS_NOOPT_FLAGS := DEBUG=no FPU_OPTIMIZATION=yes
endif

ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
DEB_SCONS_NOOPT_FLAGS += DIST_TARGET=i386
endif


DEB_DH_STRIP_ARGS := --dbg-package=ardour


DEB_SCONS_ENVVARS :=
DEB_SCONS_INVOKE = $(DEB_SCONS_ENVVARS) scons 

# For an out-of-tree build, we just cp -al all the needed files.
# It seems these are enough
BUILD_FILES = ardour.rc.in gtk2_ardour icons libs SConstruct templates tools vst

common-build-arch:: debian/stamp-scons-build
debian/stamp-scons-build:
	mkdir -p $(DEB_DESTDIR)/generic
	mkdir -p build-generic
	cp -alf $(BUILD_FILES) build-generic
	cd build-generic && $(DEB_SCONS_INVOKE) 'ARCH=$(CFLAGS)' \
		DESTDIR=$(DEB_DESTDIR)/generic \
		$(DEB_SCONS_EXTRA_FLAGS) $(DEB_SCONS_NOOPT_FLAGS)
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	mkdir -p $(DEB_DESTDIR)/i686
	mkdir -p build-i686
	cp -alf $(BUILD_FILES) build-i686
	cd build-i686 && $(DEB_SCONS_INVOKE) 'ARCH=$(I686_OPT_FLAGS)' \
		DESTDIR=$(DEB_DESTDIR)/i686 \
		DEBUG=no $(DEB_SCONS_EXTRA_FLAGS) \
		FPU_OPTIMIZATION=yes DIST_TARGET=i686
endif
ifneq (,$(findstring powerpc,$(DEB_BUILD_ARCH)))
	mkdir -p $(DEB_DESTDIR)/altivec
	mkdir -p build-altivec
	cp -alf $(BUILD_FILES) build-altivec
	cd build-altivec && $(DEB_SCONS_INVOKE) 'ARCH=$(ALTIVEC_OPT_FLAGS)' \
		DESTDIR=$(DEB_DESTDIR)/altivec \
		DEBUG=no $(DEB_SCONS_EXTRA_FLAGS)
endif
	touch $@

install/ardour::
	cd build-generic && $(DEB_SCONS_INVOKE) 'ARCH=$(CFLAGS)' \
		DESTDIR=$(DEB_DESTDIR)/generic \
		$(DEB_SCONS_EXTRA_FLAGS) $(DEB_SCONS_NOOPT_FLAGS) \
		install

ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
install/ardour-i686::
	cd build-i686 && $(DEB_SCONS_INVOKE) 'ARCH=$(I686_OPT_FLAGS)' \
		DESTDIR=$(DEB_DESTDIR)/i686 \
		DEBUG=no $(DEB_SCONS_EXTRA_FLAGS) \
		FPU_OPTIMIZATION=yes DIST_TARGET=i686 \
		install
endif

ifneq (,$(findstring powerpc,$(DEB_BUILD_ARCH)))
install/ardour-altivec::
	cd build-altivec && $(DEB_SCONS_INVOKE) 'ARCH=$(ALTIVEC_OPT_FLAGS)' \
		DESTDIR=$(DEB_DESTDIR)/altivec \
		DEBUG=no $(DEB_SCONS_EXTRA_FLAGS) install
endif

# this is bad but the only easy way to have ardour.rc generated from
# ardour.rc.in
common-install-indep:: debian/stamp-scons-build
common-install-arch:: debian/stamp-scons-build

clean:: scons-clean
scons-clean::
	$(MAKE) -f debian/rules reverse-config
	rm -rf build-generic build-i686 build-altivec
	rm -rf $(DEB_DESTDIR) debian/stamp-scons-build

	rm -rf debian/ardour-dbg
	rm -f gtk2_ardour/*.mo

# Needed at build time
# (separated in build tools, core, Glib/GTK and audio dependencies)
CDBS_BUILD_DEPENDS += , gettext,\
					  intltool,\
					  scons
CDBS_BUILD_DEPENDS += , libboost-dev,\
					  libcurl4-gnutls-dev,\
					  libfftw3-dev,\
					  libraptor1-dev (>= 1.4.21-5),\
					  liblrdf0-dev (>= 0.4.0-4),\
					  libsigc++-2.0-dev,\
					  libusb-dev,\
					  libxml2-dev (>= 2.5.7),\
					  librasqal3-dev | librasqal2-dev (>= 0.9.14)
CDBS_BUILD_DEPENDS += , libcairomm-1.0-dev (>= 1.2.4),\
					  libglade2-dev,\
					  libglademm-2.4-dev,\
					  libglib2.0-dev,\
					  libgnomecanvas2-dev,\
					  libgnomecanvasmm-2.6-dev,\
					  libgtkmm-2.4-dev,\
					  libpango1.0-dev
CDBS_BUILD_DEPENDS += , ladspa-sdk (>= 1.1-2),\
					  libasound2-dev (>= 0.9.4) [linux-any],\
					  liboss-salsa-dev [!linux-any],\
					  libaubio-dev,\
					  libjack-dev,\
					  liblo-dev,\
					  libsuil-dev,\
					  libsamplerate0-dev,\
					  libslv2-dev (>= 0.6.6-7),\
					  libsndfile1-dev,\
					  libsoundtouch-dev (>= 1.5.0),\
					  lv2-dev,\
					  liblilv-dev,\
					  vamp-plugin-sdk (>=2.1)

# Needed always/often/sometimes at runtime
CDBS_DEPENDS_ALL = python, python-twisted, python-gtk2, jackd
CDBS_RECOMMENDS_ALL = iceweasel | www-browser
CDBS_SUGGESTS_ALL = jamin, qjackctl

# Ensure only one variant is installed at a time
CDBS_PROVIDES_ardour-altivec = ardour
CDBS_PROVIDES_ardour-i686 = ardour
CDBS_CONFLICTS_ALL = ardour
CDBS_REPLACES_ALL = ardour

# Transitional quirk: ardour-gtk renamed to ardour
# TODO: drop after Squeeze (was introduced before Lenny)
CDBS_CONFLICTS_ardour += , ardour-gtk
CDBS_REPLACES_ardour += , ardour-gtk

# Transitional quirk: ardour-gtk-altivec renamed to ardour-altivec
# TODO: drop after Squeeze (was introduced before Lenny)
CDBS_CONFLICTS_ardour-altivec += , ardour-gtk-altivec
CDBS_REPLACES_ardour-altivec += , ardour-gtk-altivec

# Transitional quirk: ardour-gtk-i686 renamed to ardour-i686
# TODO: drop after Squeeze (was introduced before Lenny)
CDBS_CONFLICTS_ardour-i686 += , ardour-gtk-i686
CDBS_REPLACES_ardour-i686 += , ardour-gtk-i686

# Quirk for derivatives using different packaging name
ifeq (Ubuntu,$(shell dpkg-vendor --query Vendor))
CDBS_RECOMMENDS_ALL = firefox | www-browser
endif

## ardour 2.8.16+git20131003

=== Makefile ===
all: scons

scons:
	scons

sconsi:
	scons --implicit-deps-unchanged

cscope: cscope.out

cscope.out: cscope.files
	cscope -b

cscope.files:
	find . -name '*.[ch]' -o -name '*.cc' > $@

.PHONY: all cscope.files sconsi cscope

=== SConstruct ===
--- 
+++ 
@@ -21,7 +21,7 @@
 SConsignFile()
 EnsureSConsVersion(0, 96)
 
-ardour_version = '2.8.14'
+ardour_version = '2.8.16'
 
 subst_dict = { }
 
@@ -35,10 +35,13 @@
     ('WINDOWS_KEY', 'Set X Modifier (Mod1,Mod2,Mod3,Mod4,Mod5) for "Windows" key', 'Mod4><Super'),
     ('PROGRAM_NAME', 'Set program name (default is "Ardour")', 'Ardour'),
     ('DIST_LIBDIR', 'Explicitly set library dir. If not set, Fedora-style defaults are used (typically lib or lib64)', ''),
+    ('BOOST_PREFIX', 'What prefix was boost installed in? (default is empty, implying /usr)', ''),
     PathVariable('DESTDIR', 'Set the intermediate install "prefix"', '/'),
     PathVariable('PREFIX', 'Set the install "prefix"', '/usr/local'),
     EnumVariable('DIST_TARGET', 'Build target for cross compiling packagers', 'auto', 
-          allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 'tiger', 'panther', 'leopard', 'none' ), ignorecase=2),
+          allowed_values=('auto', 'i386', 'i686', 'x86_64', 'powerpc', 
+                          'tiger', 'lion', 'none' ), ignorecase=2),
+    BoolVariable('GENERIC', 'Force 32 bit compilation on OS X targets', 0),
     BoolVariable('AUDIOUNITS', 'Compile with Apple\'s AudioUnit library. (experimental)', 0),
     BoolVariable('COREAUDIO', 'Compile with Apple\'s CoreAudio library', 0),
     BoolVariable('GTKOSX', 'Compile for use with GTK-OSX, not GTK-X11', 0),
@@ -54,7 +57,7 @@
     BoolVariable('NLS', 'Set to turn on i18n support', 1),
     BoolVariable('SURFACES', 'Build support for control surfaces', 1),
     BoolVariable('WIIMOTE', 'Build the wiimote control surface', 0),
-    BoolVariable('SYSLIBS', 'USE AT YOUR OWN RISK: CANCELS ALL SUPPORT FROM ARDOUR AUTHORS: Use existing system versions of various libraries instead of internal ones', 0),
+    BoolVariable('SYSLIBS', 'Use existing system versions of various libraries instead of internal ones', 1),
     BoolVariable('UNIVERSAL', 'Compile as universal binary.  Requires that external libraries are already universal.', 0),
     BoolVariable('VERSIONED', 'Add revision information to ardour/gtk executable name inside the build directory', 0),
     BoolVariable('VST', 'Compile with support for VST', 0),
@@ -85,11 +88,12 @@
             self.Append (CPPPATH = other.get('CPPPATH', []))
             self.Append (LINKFLAGS = other.get('LINKFLAGS', []))
             self.Append (CCFLAGS = other.get('CCFLAGS', []))
+            self.Append (CXXFLAGS = other.get('CXXFLAGS', []))
 	self.Replace(LIBPATH = list(Set(self.get('LIBPATH', []))))
 	self.Replace(CPPPATH = list(Set(self.get('CPPPATH',[]))))
         #doing LINKFLAGS breaks -framework
         #doing LIBS break link order dependency
-    
+
     def ENV_update(self, src_ENV):
         for k in src_ENV.keys():
             if k in self['ENV'].keys() and k in [ 'PATH', 'LD_LIBRARY_PATH',
@@ -245,8 +249,7 @@
     # on glibc systems, libintl is part of libc. not true on OS X
     #
     
-    if re.search ("darwin[0-9]", config[config_kernel]):
-        buildenv.Merge ([ libraries['intl'] ])
+    buildenv.Merge ([ libraries['intl'] ])
 
     installenv.Alias ('potupdate', buildenv.PotBuild (potfile, sources))
     
@@ -266,14 +269,11 @@
 
 
 def fetch_svn_revision (path):
-    cmd = "LANG= "
-    cmd += "svn info "
-    cmd += path
-    cmd += " 2>/dev/null | awk '/^Revision:/ { print $2}'"
+    cmd = "LANG= git describe --tags HEAD"
     return commands.getoutput (cmd)
 
 def create_stored_revision (target = None, source = None, env = None):
-    if os.path.exists('.svn'):    
+    if os.path.exists('.git'):    
         rev = fetch_svn_revision ('.');
         try:
             text  = "#include <ardour/svn_revision.h>\n"
@@ -301,4 +301,3 @@
 
 def version_builder (target, source, env):
 
-    text  = "int " + env['DOMAIN'] + "_major_version = " + str (env['MAJOR']) + ";\n"

=== manual/Makefile ===

DOCNAME		= ardour_manual

# Default values, only set if not set in book Makefile
OUTDIR   ?= tmp
XMLFILE  ?= xml/$(DOCNAME).xml
XSLFILE  ?= xsl/html.xsl
CSSFILE	 ?= $(DOCNAME).css
XSLTPROC ?= xsltproc
#PWD		  = $(shell pwd)

help::
	@echo " WARNING: The Ardour Scons build script must be run before "
	@echo " building the manual. "
	@echo
	@echo " The Following is a list of supported build targets:"
	@echo
	@echo " html:"
	@echo "     Build HTML version of ardour manual."
	@echo
	@echo " test:"
	@echo "     Validate DocBook XML source."
	@echo
	@echo " format:"
	@echo "     Format DocBook XML source using xmlformat."
	@echo
	@echo " clean:"
	@echo "     Remove temporary files."
	@echo

# xsltproc -output option gives I/O errors because??, so 
# just move the html to the output directory
html:: clean
	# creating output directory
	-@mkdir $(OUTDIR)
	# generating html
	LANG=en_US.UTF-8 $(XSLTPROC) -xinclude $(XSLFILE) $(XMLFILE)
	# copy html files to output directory
	-@mv *.html $(OUTDIR)
	# copy css file to output directory
	-@cp css/$(CSSFILE) $(OUTDIR)/$(CSSFILE)
	# copy the image files to the output directory
	-@cp -r images  $(OUTDIR)/images

.PHONY : html

test::
	# validating book
	xmllint --noout --postvalid --xinclude $(XMLFILE)

.PHONY : test

format:: test
	@for file in `find xml/ -name '*.xml' -type f`; \
		do xmlformat/xmlformat.pl --in-place --backup .bak \
		--config-file xmlformat/xmlformat-ardour.conf $$file; \
		done

.PHONY : format

clean::
	@rm -rf $(OUTDIR)
	@for file in `find xml/ -name '*.bak' -type f`; do \
		rm $$file; done

.PHONY : clean

upload: html
	cd tmp && tar cf - . | bzip2 > ../man.tar.bz2
	scp man.tar.bz2 las@ardour.org:ardour.org

.PHONY : upload

=== debian/changelog ===
ardour (1:2.8.16+git20131003-1) unstable; urgency=low

  [ Jaromír Mikeš ]
  * Set priority optional.
  * Fix Vcs urls.
  * Imported Upstream version 2.8.16+git20131003

  [ Adrian Knoth ]
  * Remove obsolete 171_lilv-constness.patch
  * Generate svn_revision.cc from debian/rules
  * Add patch to fix FTBFS with libaubio4 (Closes: #733968)
  * Build-depend on libaubio >= 0.4.0

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 21 Jan 2014 20:35:34 +0100

ardour (1:2.8.16-2) unstable; urgency=low

  * Add patch to fix FTBFS (Closes: #713713)
  * Drop obsolete DMUA flag
  * Add patch to fix FTBFS with new lilv

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 04 Oct 2013 18:09:40 +0200

ardour (1:2.8.16-1) experimental; urgency=low

  * Imported Upstream version 2.8.16

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Sun, 27 Jan 2013 01:31:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: ardour
 Section: sound
-Priority: extra
+Priority: optional
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>,
  Free Ekanayaka <freee@debian.org>,
@@ -34,7 +34,7 @@
  ladspa-sdk (>= 1.1-2),
  libasound2-dev (>= 0.9.4) [linux-any],
  liboss-salsa-dev [!linux-any],
- libaubio-dev,
+ libaubio-dev (>= 0.4.0),
  libjack-dev,
  liblo-dev,
  libsuil-dev,
@@ -46,10 +46,9 @@
  liblilv-dev,
  vamp-plugin-sdk (>=2.1)
 Standards-Version: 3.9.4
-DM-Upload-Allowed: yes
 Homepage: http://www.ardour.org/
-Vcs-Git: git://git.debian.org/git/pkg-multimedia/ardour.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/ardour.git;a=summary
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/ardour.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/ardour.git
 
 Package: ardour
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -49,7 +49,7 @@
 BUILD_FILES = ardour.rc.in gtk2_ardour icons libs SConstruct templates tools vst
 
 common-build-arch:: debian/stamp-scons-build
-debian/stamp-scons-build:
+debian/stamp-scons-build: libs/ardour/svn_revision.cc
 	mkdir -p $(DEB_DESTDIR)/generic
 	mkdir -p build-generic
 	cp -alf $(BUILD_FILES) build-generic
@@ -74,6 +74,11 @@
 		DEBUG=no $(DEB_SCONS_EXTRA_FLAGS)
 endif
 	touch $@
+
+libs/ardour/svn_revision.cc:
+	echo '#include "ardour/svn_revision.h"' > $@
+	echo "namespace ARDOUR { extern const char* svn_revision = \"${DEB_VERSION}\"; }" >> $@
+
 
 install/ardour::
 	cd build-generic && $(DEB_SCONS_INVOKE) 'ARCH=$(CFLAGS)' \
@@ -110,6 +115,7 @@
 
 	rm -rf debian/ardour-dbg
 	rm -f gtk2_ardour/*.mo
+	rm -f libs/ardour/svn_revision.cc
 
 # Needed at build time
 # (separated in build tools, core, Glib/GTK and audio dependencies)
@@ -136,7 +142,7 @@
 CDBS_BUILD_DEPENDS += , ladspa-sdk (>= 1.1-2),\
 					  libasound2-dev (>= 0.9.4) [linux-any],\
 					  liboss-salsa-dev [!linux-any],\
-					  libaubio-dev,\
+					  libaubio-dev (>= 0.4.0),\
 					  libjack-dev,\
 					  liblo-dev,\
 					  libsuil-dev,\

=== debian/watch ===
version=3
# Homepage  Pattern  [Version  [Action]]
http://www.ardour.org/source_downloads http://releases.ardour.org/ardour-(2.[\d\.]+)\.tar\.bz2

## ardour 2.8.16+git20131003+dfsg1

=== debian/changelog ===
ardour (1:2.8.16+git20131003+dfsg1-1~deb8u1) jessie; urgency=medium

  * Repack to remove libs/pdb/dmalloc.cc. (Closes: #810754)
  * debian/patches/debian/patches/190_exclude_dmalloc.patch: Do not build
    dmalloc.cc.
  * debian/copyright:
    - Add libs/pdb/dmalloc.cc to Files-Excluded.
    - Remove libs/pdb/dmalloc.cc paragraph.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 18 Jan 2016 16:10:25 +0100

ardour (1:2.8.16+git20131003-4) unstable; urgency=medium

  * Upload to unstable.
  * Bump Standards.
  * Add exec-code to desktop files.
  * Update copyright file. (Closes: #749363)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 21 Oct 2014 02:35:29 +0200

ardour (1:2.8.16+git20131003-3) experimental; urgency=low

  * Team upload

  [ Jaromír Mikeš ]
  * Add -dbg package

  [ Felipe Sateler ]
  * Upload to experimental

 -- Felipe Sateler <fsateler@debian.org>  Thu, 22 May 2014 14:39:25 -0400

ardour (1:2.8.16+git20131003-2) unstable; urgency=low

  [ Felipe Sateler ]
  * Drop unused build-dependency on libslv2-dev. (Closes: #740832)

  [ Jaromír Mikeš ]
  * Bump Standards.
  * Set dh/compat 9.
  * Added Keywords to desktop file.
  * Disable debug hints.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 05 May 2014 02:13:26 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends: cdbs,
  autotools-dev,
  devscripts,
- debhelper,
+ debhelper (>= 9),
  dh-buildinfo,
  gettext,
  intltool,
@@ -39,13 +39,12 @@
  liblo-dev,
  libsuil-dev,
  libsamplerate0-dev,
- libslv2-dev (>= 0.6.6-7),
  libsndfile1-dev,
  libsoundtouch-dev (>= 1.5.0),
  lv2-dev,
  liblilv-dev,
  vamp-plugin-sdk (>=2.1)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://www.ardour.org/
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/ardour.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/ardour.git
@@ -115,6 +114,21 @@
  Further information can be
  found at <http://ardour.org/>.
 
+Package: ardour-dbg
+Section: debug
+Priority: extra
+Architecture: any
+Depends: ardour (= ${binary:Version}) | ardour-altivec (= ${binary:Version}) | ardour-i686 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends},
+Suggests: ${shlibs:Suggests}
+Description: digital audio workstation (debug)
+ Ardour is a multichannel hard disk recorder (HDR) and digital audio
+ workstation (DAW).  It can be used to control, record, edit and run
+ complex audio setups. 
+ .
+ This package contains the debugging symbols.
+
 Package: ardour-altivec
 Architecture: powerpc
 Depends: ${shlibs:Depends},
